use rouille::{router, Request, Response, try_or_400, post_input};
use crate::random_names::get_name;
use crate::state::{Mailbox, State};

pub fn http_handler(request: &Request, state: &State) -> Response {
    router!(request,
        (GET) (/) => {
            rouille::Response::text("hello world")
        },

        (GET) (/ffff) => {
            rouille::Response::html("<h1>email stuff</h1>")
        },

        (POST) (/ffff) => {
            let data = try_or_400!(post_input!(request, {
                domain: String
        }));

            let email = format!("{}@{}", get_name(), data.domain);

            println!("{}", email);

            state.lock().unwrap().insert(email.clone(), Mailbox::new(email));

            rouille::Response::text("ok")
        },

        (GET) (/ffff/{email: String}) => {
            println!("{}", email);

            if let Some(mailbox) = state.lock().unwrap().get(&email) {
                rouille::Response::text(format!("{}: {}", &mailbox.email, &mailbox.messages.len()))
            } else {
                rouille::Response::text("Mailbox not found")
            }
        },

        _ => rouille::Response::empty_404()
    )
}
